///////////////////////////////////////////////////////////
//
//  File: SFImage.h
//
//  Suprema UniFinger Engine Image SDK
//  Header File
//
//  Copyright (C) 2005, Suprema Inc.
//
///////////////////////////////////////////////////////////

#ifndef SFIMAGE_H_INCLUDED
#define SFIMAGE_H_INCLUDED

#ifdef SFA_EXPORTS
#define SFA_API __declspec(dllexport)
#else
#define SFA_API
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define SF_TEMPLATESIZE_MIN 256
#define SF_TEMPLATESIZE_MAX 1024

#define SF_VERIFYFAIL    0
#define SF_MATCHFAIL     0
#define SF_MATCHTIMEOUT  128
#define SF_MATCHABORT    129

#define SF_SUCCESS       1

SFA_API int __stdcall SF_Initialize();
SFA_API void __stdcall SF_Uninitialize();

SFA_API int __stdcall SF_Extraction( unsigned char* Image, int Width, int Height, int Resolution, int LimitSize, unsigned char* Template, int* TemplateSize );
SFA_API int __stdcall SF_GetEnrollQuality();

SFA_API int __stdcall SF_Matching( unsigned char* Template1, unsigned char* Template2, int SecurityLevel );
SFA_API int __stdcall SF_MatchingDB( unsigned char** TemplateDB, int Count, int* Match, unsigned char* Template, int SecurityLevel, int Timeout );
SFA_API void __stdcall SF_AbortMatching();

SFA_API void __stdcall SF_RotateTemplate( unsigned char* Template );

#ifdef __cplusplus
}
#endif

#endif // SFIMAGE_H_INCLUDED
