// Image.h : header file
//

#ifndef __IMAGE_H__
#define __IMAGE_H__

class CImage {
protected:
    HGLOBAL m_hImage;
    CSize m_Size;
    int m_BitCount;
    CString m_Format;
    CPalette* m_pPal;
    int m_DibSize;

public:
    CImage();
    virtual ~CImage() { Free(); };
    void Free();

    BOOL IsDataNull() { return ( m_hImage == NULL ); }
    CSize GetSize() { return m_Size; }
    CRect GetRect() { return CRect( 0, 0, m_Size.cx, m_Size.cy ); }
    int GetWidth() { return m_Size.cx; }
    int GetHeight() { return m_Size.cy; }
    int GetBitCount() { return m_BitCount; }
    CString GetFormat() { return m_Format; }
    BOOL CreateGrayImage( BYTE* Data, int Width, int Height );

    void Draw( HDC hDC, LPRECT sourceRect, LPRECT destRect );
    double Draw( CDC* pDC, CRect& Rect, BOOL bStretch = FALSE );
};

int DIBNumColors( LPBITMAPINFOHEADER lpbi );
extern "C" int LoadBMPImage( const char* Name, int *pWidth, int *pHeight, unsigned char **pImage );

/////////////////////////////////////////////////////////////////////////////
#endif