// SFImageTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SFImageTest.h"
#include "SFImageTestDlg.h"

#include <mmsystem.h> // for PlaySound()

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSFImageTestDlg dialog

CSFImageTestDlg::CSFImageTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSFImageTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSFImageTestDlg)
	m_Resolution = 500;
	m_EnrollQuality = 2;
	m_SecurityLevel = 3;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_Template = 0;
    for ( int i = 0 ; i < TEMPLATE_COUNT ; i++ ) {
        memset( m_EnrollTemplate[ i ], 0, SF_TEMPLATESIZE_MAX );
    }
}

void CSFImageTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSFImageTestDlg)
	DDX_Text(pDX, IDC_RESOLUTION, m_Resolution);
	DDV_MinMaxInt(pDX, m_Resolution, 1, 1000);
	DDX_CBIndex(pDX, IDC_ENROLL_QUALITY, m_EnrollQuality);
	DDX_CBIndex(pDX, IDC_SECURITY_LEVEL, m_SecurityLevel);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSFImageTestDlg, CDialog)
	//{{AFX_MSG_MAP(CSFImageTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ENROLL, OnEnroll)
	ON_BN_CLICKED(IDC_IDENTIFY, OnIdentify)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSFImageTestDlg message handlers

BOOL CSFImageTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
    if ( !SF_Initialize() ) {
        PostQuitMessage( 0 );
    }

    CRect Rect;
    GetClientRect( &Rect );
    int left = Rect.left + 10;
    int right = Rect.right - 10;

    GetDlgItem( IDOK )->GetWindowRect( &Rect );
    ScreenToClient( &Rect );
    int top = Rect.top;
    int bottom = top + Rect.Height();
    m_MessageRect.SetRect( left, top, right, bottom );

    top = bottom + 8;
    bottom = top + ( right - left ) * 320 / 280;
    m_ImageRect.SetRect( left + 2, top + 2, right - 2, bottom - 2 );

    return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSFImageTestDlg::OnDestroy() {
	CDialog::OnDestroy();

    SF_Uninitialize();
}

void CSFImageTestDlg::OnSysCommand(UINT nID, LPARAM lParam) {
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSFImageTestDlg::OnPaint() {
	CPaintDC dc( this ); // device context for painting

	if ( IsIconic() ) {
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else {
        if ( !m_Image.IsDataNull() ) {
//            m_Image.Draw( dc.GetSafeHdc(), CRect( 0, 0, m_ImageRect.Width(), m_ImageRect.Height() ), CRect( m_ImageRect.left, m_ImageRect.top, m_ImageRect.right, m_ImageRect.bottom ) );
            m_Image.Draw( &dc, CRect( m_ImageRect.left, m_ImageRect.top, m_ImageRect.right, m_ImageRect.bottom ), FALSE );
        }

        m_ImageRect.InflateRect( 2, 2 );
        dc.DrawEdge( m_ImageRect, EDGE_SUNKEN, BF_RECT );
        m_ImageRect.DeflateRect( 2, 2 );

        dc.DrawEdge( m_MessageRect, EDGE_SUNKEN, BF_RECT );

        CFont Font;
        Font.CreatePointFont( 100, "MS Sans Serif" );
        CFont* pOldFont = dc.SelectObject( &Font );

        dc.SetBkMode( TRANSPARENT );
        dc.DrawText( m_Message, m_MessageRect, DT_SINGLELINE | DT_VCENTER | DT_CENTER );

		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSFImageTestDlg::OnQueryDragIcon() {
	return (HCURSOR) m_hIcon;
}

void CSFImageTestDlg::OnOK() {
//    CDialog::OnOK();
}

void CSFImageTestDlg::MessageOut( CString Message, int Sound ) {
    if ( Sound == 1 ) {
		PlaySound( "chimes.wav", NULL, SND_ASYNC );
	}
	else if ( Sound == 0 ) {
		PlaySound( "chord.wav", NULL, SND_ASYNC );
	}

    m_Message = Message;
    InvalidateRect( m_MessageRect );
    UpdateWindow();
}

void CSFImageTestDlg::OnEnroll() {
    int ret;
    CString str;

    BYTE* Image;
    int Width, Height;

    CFileDialog FileDialog( TRUE, "bmp", "*.bmp", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Bitmap image(*.bmp)" );
    if ( FileDialog.DoModal() != IDOK ) {
        return;
    }

    if ( !LoadBMPImage( FileDialog.GetPathName(), &Width, &Height, &Image ) ) {
        MessageOut( "Cannot open BMP file", 0 );
        return;
    }

    m_Image.CreateGrayImage( Image, Width, Height );

    InvalidateRect( m_ImageRect );
    UpdateWindow();

    UpdateData();

    if ( SF_Extraction( Image, Width, Height, m_Resolution, SF_TEMPLATESIZE_MAX, m_EnrollTemplate[ m_Template ], NULL ) == 0 ) {
        free( Image );
        MessageOut( "Not enough image", 0 );
        return;
    }

    free( Image );

    ret = SF_GetEnrollQuality();
    if ( ret < m_EnrollQuality * 10 + 30 ) {
        str.Format( "Too low quality [Q:%d]", ret );
        MessageOut( str, 0 );
        return;
    }

    str.Format( "Enrollment success (No.%d) [Q:%d]", m_Template + 1, ret );
    MessageOut( str, 1 );

    if ( ++m_Template == TEMPLATE_COUNT ) {
        m_Template = 0;
    }
}

void CSFImageTestDlg::OnIdentify() {
    int ret, i;
    CString str;

    BYTE* Image;
    int Width, Height;

    CFileDialog FileDialog( TRUE, "bmp", "*.bmp", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Bitmap image(*.bmp)" );
    if ( FileDialog.DoModal() != IDOK ) {
        return;
    }

    if ( !LoadBMPImage( FileDialog.GetPathName(), &Width, &Height, &Image ) ) {
        MessageOut( "Cannot open BMP file", 0 );
        return;
    }

    m_Image.CreateGrayImage( Image, Width, Height );

    InvalidateRect( m_ImageRect );
    UpdateWindow();

    UpdateData();

    BYTE CurrentTemplate[ SF_TEMPLATESIZE_MAX ];

    if ( SF_Extraction( Image, Width, Height, m_Resolution, SF_TEMPLATESIZE_MAX, CurrentTemplate, NULL ) == 0 ) {
        free( Image );
        MessageOut( "Not enough image", 0 );
        return;
    }

    free( Image );

    MessageOut( "Extraction completed" );

    BYTE* Template[ TEMPLATE_COUNT ];
    for ( i = 0 ; i < TEMPLATE_COUNT ; i++ ) {
        Template[ i ] = m_EnrollTemplate[ i ];
    }

    if ( ( ret = SF_MatchingDB( Template, TEMPLATE_COUNT, &i, CurrentTemplate, m_SecurityLevel + 1, 1000 ) ) == SF_SUCCESS ) {
        str.Format( "Identification success (No.%d)", i + 1 );
        MessageOut( str, 1 );
    }
    else if ( ret == SF_MATCHFAIL ) {
        MessageOut( "Identification fail", 0 );
    }
    else if ( ret == SF_MATCHTIMEOUT ) {
        MessageOut( "Identification timeout", 0 );
    }
}
